-- By D4KiR

local ID = 0
function CreateActionButton(tab)
	ID = ID + 1
	tab.align = tab.align or "CENTER"
	tab.x = tab.x or 0
	tab.y = tab.y or 0
	local btn = CreateFrame("Button", "Example", ActionButton1:GetParent(), "ActionButtonTemplate, SecureActionButtonTemplate")
	btn:SetWidth(36)
	btn:SetHeight(36)
	btn:SetPoint(tab.align, UIParent, tab.align, tab.x, tab.y)
	btn:RegisterForDrag("LeftButton", "RightButton")
	btn.ID = ID

	function btn:OnReceiveDrag(actiontype, actionid, load)
		if InCombatLockdown() then
			return
		end

		local selectType, selectID, _, selectSpell = GetCursorInfo()
		if not load then
			ClearCursor()
		end

		selectType = actiontype or selectType
		selectID = actionid or selectID
		selectSpell = actionid or selectSpell
		selectID = tonumber(selectID)
		selectSpell = tonumber(selectSpell)

		local texture = nil
		local gameID = selectID
		local gameType = selectType
		local gameSpell = selectSpell

		if gameType == "item" then
			gameID = "item:" .. gameID
			texture = select(10, GetItemInfo(gameID))
		elseif gameType == "spell" then
			gameID = gameSpell
			texture = select(3, GetSpellInfo(gameID))
		elseif gameType == "macro" then
			 _,texture = GetMacroInfo(gameID)
		elseif gameType == "mount" then
			local found = false
			for i = 1, GetNumCompanions("MOUNT") do
				-- creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected, mountID = C_MountJournal.GetDisplayedMountInfo(index)
				local _, _, icon, _, _, _, _, _, _, _, _, mountID = C_MountJournal.GetDisplayedMountInfo(i)
				if mountID == gameID then
					found = true
					texture = icon
					gameID = i
					self.mount = mountID
					break
				end
			end
			if not found then
				--deb("NOT FOUND", GetNumCompanions("MOUNT"))
			end
		else
			return
		end

		self:SetAttribute("type", gameType)
		self:SetAttribute(gameType, gameID)
		--self.icon:SetTexture(texture)

		if D4HUDPC ~= nil then
			D4HUDPC[btn.ID] = D4HUDPC[btn.ID] or {}
			D4HUDPC[btn.ID].id = selectSpell or selectID
			D4HUDPC[btn.ID].type = selectType
			D4HUDPC[btn.ID].texture = texture
		end
	end

	function btn:LoadAction()
		if D4HUDPC ~= nil then
			D4HUDPC[btn.ID] = D4HUDPC[btn.ID] or {}
			btn.id = D4HUDPC[btn.ID].id or 0
			btn.id = tonumber(btn.id)
			btn.type = D4HUDPC[btn.ID].type or ""
			btn.texture = D4HUDPC[btn.ID].texture or ""
			if btn.type ~= "" and btn.id > 0 then
				btn:OnReceiveDrag(btn.type, btn.id, true)
			end
		end
	end
	btn:LoadAction()

	local validTypes = {item = 1,spell = 1, macro = 1, mount = 1}

	-- There's likely a better way, but this is a cheap way to prevent
	-- a "click" on a btn when dropping something onto it.
	-- If the select contains a valid object, nil the btn's type...
	btn:SetScript("PreClick",function(self)
		if validTypes[GetCursorInfo()] and not InCombatLockdown() then
			self:SetAttribute("type", nil)
		end
	end)
	-- ...and in the PostClick, define the btn
	btn:SetScript("PostClick",function(self)
		if validTypes[GetCursorInfo()] then
			btn:OnReceiveDrag()
		else
			local btntype = self:GetAttribute("type")
			if btntype == "mount" then
				local mountID = self.mount
				if mountID ~= nil then
					C_MountJournal.SummonByID(mountID)
				end
			end
		end
	end)

	return btn
end
